# encoding: utf-8

import es, popuplib, playerlib

import psyco
psyco.full()

info = es.AddonInfo()
info.name = 'ratio_limite'
info.version = '1.0.0'
info.author = 'Fantole'
info.url = 'http://addons.eventscripts.com/addons/view/ratio_limite'
info.description = 'Script Anti-Roxor, limite l\'utilisation de certaines armes selon le Ratio du joueur'
info.tags = 'antirox, ratio_limite, ratio limite, anti roxor, ratio' # mots clés

es.ServerVar('ratio_limite_ver', info.version, 'Version du script ratio_limite').makepublic()

ratio_limite_max = es.ServerVar('ratio_limite_max', 0, "Ratio maximum avant la restriction des armes")
ratio_limite_armes = es.ServerVar('ratio_limite_armes', 0, "Arme a restreinte pour un Roxor")
ratio_limite_check_hurt = es.ServerVar('ratio_limite_check_hurt', 0, "Verifie le Ratio du joueur quand il touche un ennemie et lui applique une Sanction")
ratio_limite_check_spawn = es.ServerVar('ratio_limite_check_spawn', 0, "Verifie le Ratio du joueur quand il spawn, ne le sanctionne pas mais affiche un message d'avertissement")
ratio_limite_check_kill = es.ServerVar('ratio_limite_check_kill', 0, "Verifie le Ratio du joueur quand il tue un ennemie et lui applique une sanction")
ratio_limite_regen_hurt = es.ServerVar('ratio_limite_regen_hurt', 0, "Si un joueur subit des degats avec une armes restreinte sur le joueur d'un face, il regagnera les HP perdu")
ratio_limite_sanction = es.ServerVar('ratio_limite_sanction', 0, "Sanction applique sur un joueur au Ratio superieur a la limite, 0 = Meurt, 1 = Slap, 2 = Drop, 3 Slap + Drop")
ratio_limite_message = es.ServerVar('ratio_limite_message', 0, "0 = Affiche un message a la victime est a l'attaquant, 1 = Affiche un message a la Victime, 2 = Affiche un message a l'Attaquant")
ratio_limite_seconde = es.ServerVar('ratio_limite_seconde', 0, "Duree d'affichage en secondes de la fenetre au Spawn du joueur si son Ratio est > a la limite")

es.mexec('../addons/eventscripts/ratio_limite/config.cfg')

ratio_limite_armes = str(ratio_limite_armes).replace('weapon_', '').split(' ')

def load():
    es.msg('#multi', '#lightgreen[Ratio Limite]#green ON')
    es.regsaycmd("!arme", "ratio_limite/arme", "Affiche les armes retreintes par un trop grand Ratio")
    es.regsaycmd("!ratio", "ratio_limite/ratio", "Affiche le Ratio du joueur qui a utilisé la commande")

def unload():
    es.msg('#multi', '#lightgreen[Ratio Limite]#green OFF')
    es.unregsaycmd("!arme")
    es.unregsaycmd("!ratio")

def arme():
    userid = int(es.getcmduserid())
    
    arme_popup = popuplib.easymenu('armes_restreintes', None, None)
    arme_popup.settitle("** Armes Restreintes **")
    
    for weapon in ratio_limite_armes:
        arme_popup.addoption(weapon, weapon)
        
    arme_popup.send(userid)

def ratio():
    userid = int(es.getcmduserid())
    joueur = playerlib.getPlayer(userid)
    kills = int(joueur.attributes['kills'])
    joueur.refreshAttributes()
    deaths = int(joueur.attributes['deaths'])

    if deaths == 0:
        deaths = 1
    
    ratio = float(kills / deaths)
    es.tell(userid, '#multi', '#lightgreen[Ratio Limite]#default Ratio =#green %s' % ratio)

def player_spawn(ev):
    es_userteam = int(ev['es_userteam'])
    if es_userteam > 1:
        es_userdeaths = int(ev['es_userdeaths'])

        if es_userdeaths == 0:
            es_userdeaths = 1
        
        es_userkills = int(ev['es_userkills'])
        userid = ev['userid']

        es.tell(userid, '#multi', '#lightgreen[Ratio Limite]#default Tapes #green!ratio#default dans le Chat pour afficher ton Ratio')
        
        if int(ratio_limite_check_spawn) == 1 and (es_userkills / es_userdeaths) >= int(ratio_limite_max):
            es.menu(ratio_limite_seconde, userid, '.****[ ATTENTION ]****.\n \n->1 Ton ratio est supérieur ou égal à %d\n->2 Tu dois passer à un Gun ou à une arme Autorisée !\n->3 Pour voir la liste des armes interdite\n->4 Tapes !arme dans le Chat' % int(ratio_limite_max))
    else:
        return

def player_death(ev):
    es_attackerteam = int(ev['es_attackerteam'])
    es_userteam = int(ev['es_userteam'])

    if int(ratio_limite_check_kill) == 1 and es_userteam != es_attackerteam:
        es_attackerdeaths = int(ev['es_attackerdeaths'])

        es_attackerdead = int(ev['es_attackerdead'])

        if es_attackerdeaths == 0:
            es_attackerdeaths = 1
            
        es_attackerkills = int(ev['es_attackerkills'])
        weapon = ev['weapon']

        if (es_attackerkills / es_attackerdeaths) >= int(ratio_limite_max) and es_attackerdead == 0 and weapon in ratio_limite_armes:
            attacker = int(ev['attacker'])
            userid = int(ev['userid'])
            es_attackername = ev['es_attackername']
            es_attackerhealth = int(ev['es_attackerhealth'])
            
            afficher_message(attacker, weapon, userid, es_attackername, None, None, 0, int(ratio_limite_sanction))
            sanction(attacker, None, int(ratio_limite_sanction), es_attackerhealth)
        

def player_hurt(ev):
    # Variables Victime
    es_userteam = int( ev['es_userteam'])
    
    # Variables Attaquant
    es_attackerteam = int(ev['es_attackerteam'])
    
    if int(ratio_limite_check_hurt) == 1 and es_userteam != es_attackerteam:
        es_attackerdeaths = int(ev['es_attackerdeaths'])

        if es_attackerdeaths == 0:
            es_attackerdeaths = 1
            
        es_attackerkills = int(ev['es_attackerkills'])

        if (es_attackerkills / es_attackerdeaths) >= int(ratio_limite_max) and weapon in ratio_limite_armes:
            # Variables Victime
            userid = int(ev['userid'])
            health = int(ev['health'])
            dmg_health = int(ev['dmg_health'])
            dmg_armor = int(ev['dmg_armor'])
            es_username = ev['es_username']
            es_userdead = int(ev['es_userdead'])

            # Variables Attaquant
            attacker = int(ev['attacker'])
            weapon = ev['weapon']
            es_attackername = ev['es_attackername']
            es_attackerweapon = ev['es_attackerweapon']
            es_attackerdead = int(ev['es_attackerdead'])
            es_attackerhealth = int(ev['es_attackerhealth'])

            if int(ratio_limite_regen_hurt) == 1 and es_userdead == 0:
                joueur = playerlib.getPlayer(userid)
                joueur.set("health", health + dmg_health)
                

            if es_attackerdead == 0:
                afficher_message(attacker, weapon, userid, es_attackername, dmg_health, dmg_armor, int(ratio_limite_regen_hurt), int(ratio_limite_sanction))
                sanction(attacker, dmg_health, int(ratio_limite_sanction), es_attackerhealth)
            else:
                return
        else:
            return
    else:
        return

def sanction(attacker, dmg_health, sanction, es_attackerhealth):
    if sanction == 0:
        es.server.queuecmd('damage %s %d' % (attacker, es_attackerhealth))
        
    if sanction == 1 or sanction == 3:
        slap_pos_x = random.randint(100,350)
        slap_pos_y = random.randint(250,450)
        slap_pos_z = random.randint(100,350)
        slap_pos_x_reverse = random.randint(0,1)
        slap_pos_y_reverse = random.randint(0,1)
    
        rand_sound = random.randint(1,3)
    
        if int(slap_pos_x_reverse) == 1:
            slap_pos_x = slap_pos_x_reverse - slap_pos_x
        if int(slap_pos_y_reverse) == 1:
            slap_pos_y = slap_pos_y_reverse - slap_pos_y
    
        es.setplayerprop(attacker, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "%d,%d,%d" % (slap_pos_x, slap_pos_y, slap_pos_z))
        es.server.queuecmd('es_xplaysound %d player/damage%d.wav 1.0' % (attacker, rand_sound))
        
        if dmg_health == None:
            dmg_health = 10
            
        es.server.queuecmd('damage %s %d' % (attacker, dmg_health))
        
    if sanction == 2 or sanction == 3:
        es.server.cmd('es_xsexec %d drop' % attacker)
        
    

def afficher_message(attacker, weapon, userid, es_attackername, dmg_health, dmg_armor, regen_hurt, sanction):
    if int(ratio_limite_message) == 0 or int(ratio_limite_message) == 1:
        if regen_hurt == 1:
            es.tell(userid, '#multi', '#lightgreen[Ratio Limite]#defaultTu récupère#green %d HP - %d Gilet#default, car#green %s #defaultt\'a attaqué avec #green%s #defaultalors que son Ratio est trop grand' % (dmg_health, dmg_armor, es_attackername, weapon))
        elif regen_hurt == 0:
            es.tell(userid, '#multi', '#lightgreen[Ratio Limite]#green %s est Mort pour t\'avoir tué avec l\'arme#green %s #defaultrestreinte par son Ratio' % (es_attackername, weapon))
            
    if int(ratio_limite_message) == 0 or int(ratio_limite_message) == 2:
        if sanction == 0:
            es.tell(attacker, '#multi', '#lightgreen[Ratio Limite]#defaultTu es Mort pour avoir utilisé le #green %s #defaultalors que ton Ratio est égal ou supérieur à#green %d' % (weapon, int(ratio_limite_max)))

        elif sanction > 0:
            es.tell(attacker, '#multi', '#lightgreen[Ratio Limite]#defaultTon Ratio est supérieur à#green %d #defaulttu n\'a pas le droit à cette arme' % int(ratio_limite_max))
    
    
